$.browser.msie 错误,jq报错的原因及其解决

Micah2014年11月28日 09:42 分类 : Web前端  > JQuery
阅读: 1545

分享到微信朋友圈

$.browser是通过正则表达式来匹配userAgent来判断浏览器版本和种类的.jquery1.3.2版本的文档中已经声明jquery.browser及jquery.browser.version建议弃用,可以使用jquery.support来代替。

TypeError: $.browser is undefined


if ($.browser.msie && $.browser.version == 6.0 && $(document).scrollTop() !== 0){
$retop.css({ 'opacity': 1 })
}


$.browser是通过正则表达式来匹配userAgent来判断浏览器版本和种类的.jquery1.3.2版本的文档中已经声明jquery.browser及jquery.browser.version建议弃用,可以使用jquery.support来代替。


jQuery从 1.9 版开始,移除了 $.browser 和 $.browser.version , 取而代之的是 $.support 。


jQuery在更新的2.0 版本中,将不再支持 IE 6/7/8。 以后,如果用户需要支持 IE 6/7/8,只能使用 jQuery 1.9或者jQuery1.10.1等。 如果要全面支持 IE,并混合使用 jQuery 1.9 和 2.0, 官方的解决方案是:


<!--[if lt IE 9]>
<script src='http://keleyi.com/keleyi/pmedia/jquery-1.10.1.min.js'></script>
<![endif]-->
<!--[if gte IE 9]>
<script src='http://keleyi.com/keleyi/pmedia/jquery-2.0.2.min.js'></script>
<![endif]-->


从长久来看,这样有利于在复杂情况下根据浏览器特性进行分别处理, 而不是简单的检测浏览器类型和版本。 但目前很多旧程序的移植恐怕无法直接过渡为根据浏览器支持特性, 所以在网上找了一些能够直接替换的解决办法。

判断浏览器类型:

$.browser.mozilla = /firefox/.test(navigator.userAgent.toLowerCase());
$.browser.webkit = /webkit/.test(navigator.userAgent.toLowerCase());
$.browser.opera = /opera/.test(navigator.userAgent.toLowerCase());
$.browser.msie = /msie/.test(navigator.userAgent.toLowerCase());

等号后面的表达式返回的就是 true/false, 可以直接用来替换原来的 $.browser.msie 等。


检查是否为 IE 6-8:
if (!$.support.leadingWhitespace) {}

不推荐使用浏览器类型和版本来进行判断。


Micah
IT技术整理

精彩评论:0

还可以输入250个字 评论

评论成功

评论失败

 

微信公众号

微博